

#include <libopencm3/stm32/rcc.h>
#include <libopencm3/stm32/gpio.h>
#include <libopencm3/stm32/timer.h>
#include <libopencm3/cm3/nvic.h>
#include "stmcommon.h"


uint8_t VidDat[] = { 
  0x01, 0x00, 0x00, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x00, 0x00,  
  0x00, 0x00, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,  
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,
  0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x00, 0x00, 0x08 };



/* Set STM32 to 72 MHz. */
void clock_setup(void){

    rcc_clock_setup_in_hse_8mhz_out_72mhz();     
   // rcc_clock_setup_pll(&rcc_hse_configs[RCC_CLOCK_HSE8_72MHZ]); // old library cant do this.
}

void gpio_setup(void){

    rcc_periph_clock_enable(RCC_GPIOA); 
    rcc_periph_clock_enable(RCC_GPIOB);
    rcc_periph_clock_enable(RCC_GPIOC); 
            
    gpio_set_mode(GPIOA, GPIO_MODE_OUTPUT_10_MHZ,  GPIO_CNF_OUTPUT_PUSHPULL, 
       0 | GPIO0 | GPIO1 | GPIO2 | GPIO3 );    
//        GPIO0 | GPIO1 | GPIO2 | GPIO3 | GPIO4 | GPIO5 | GPIO6 | GPIO7 | GPIO8 | GPIO9 | GPIO10 | GPIO11 | GPIO12 | GPIO13 | GPIO14 | GPIO15 );    
                
                
    gpio_set_mode(GPIOB, GPIO_MODE_OUTPUT_2_MHZ,  GPIO_CNF_OUTPUT_PUSHPULL, 
       0 | GPIO12 | GPIO13 | GPIO14 | GPIO15);              
//        GPIO0 | GPIO1 |         GPIO3 | GPIO4 | GPIO5 | GPIO6 | GPIO7 | GPIO8 | GPIO9 | GPIO10 | GPIO11 | GPIO12 | GPIO13 | GPIO14 | GPIO15 );  
        
        
    gpio_set_mode(GPIOC, GPIO_MODE_OUTPUT_2_MHZ,  GPIO_CNF_OUTPUT_PUSHPULL, 
       0);    
//        GPIO13 | GPIO14 | GPIO15 );
    
        
    // pullup on input (not strong enough)
   // gpio_set(GPIOC, GPIO14);
   // gpio_set_mode(GPIOC, GPIO_MODE_INPUT, GPIO_CNF_INPUT_PULL_UPDOWN, GPIO14);
   

}

void timer2_init(void){

    rcc_periph_clock_enable(RCC_TIM2);
    
    timer_set_prescaler(TIM2, 1); // 72Mhz / 1 / 144 = 500kHz
    timer_set_period(TIM2, 144);
    
    nvic_enable_irq(NVIC_TIM2_IRQ);
    timer_enable_irq(TIM2, TIM_DIER_UIE);
    
    timer_enable_counter(TIM2);

}

void tim2_isr(void) { 
  timer_clear_flag(TIM2, TIM_SR_UIF);
      
  if (gpio_get(GPIOC, GPIO14)) {  
    gpio_set(GPIOC, GPIO13);
  } else {
    gpio_clear(GPIOC, GPIO13);
  }
   
}

void longDelay(uint32_t d) {
  while(d--) NOP();
}


#define FLMBIT GPIOB, GPIO12
#define MBIT   GPIOB, GPIO13
#define CL1BIT GPIOB, GPIO14
#define CL2BIT GPIOB, GPIO15


#define FLMHigh()  gpio_set   ( FLMBIT );
#define FLMLow()   gpio_clear ( FLMBIT );
#define MHigh()    gpio_set   ( MBIT   );
#define MLow()     gpio_clear ( MBIT   );
#define CL1High()  gpio_set   ( CL1BIT );
#define CL1Low()   gpio_clear ( CL1BIT );
#define CL2High()  gpio_set   ( CL2BIT );
#define CL2Low()   gpio_clear ( CL2BIT );

#define PulseCL2() CL2High(); CL2Low()
#define PulseCL1() CL1High(); CL1Low()
#define ToggleM()  gpio_toggle( MBIT );

int main(void){

    uint8_t i, j;

    clock_setup();
    gpio_setup();
  //  timer2_init();
            
    
    while (1) {
      
      FLMHigh();
      ToggleM();  
    //  gpio_set   ( GPIOB, GPIO0 );      
      
      #define LINES 128
      #define BLOCKS 120
      for ( j = LINES; j; j--) {    // lines
        if (j == 1) gpio_set   ( GPIOB, GPIO0 );
        for ( i = BLOCKS; i ; i--) {  // pixel sets
	//  if (i == BLOCKS-2) gpio_clear   ( GPIOB, GPIO0 );	  
          gpio_port_write(GPIOA, VidDat[i-1]);
          if ((j & 0x0F) == 0) gpio_port_write(GPIOA, 0x0F);
	  PulseCL2(); 
	}
	PulseCL1();
	if (j == LINES) FLMLow();
      }
      
      
    
    }
    
    
    return 0;
}
















































